using Fantasy;
using Fantasy.Async;
using Fantasy.Network;
using Fantasy.Network.Interface;
using Fantasy.Platform.Net;
using NB.Map;

namespace NB.Gate;

public class C2G_EnterRoomRequestHandler : MessageRPC<C2G_EnterRoomRequest, G2C_EnterRoomResponse>
{
    protected override async FTask Run(Session session, C2G_EnterRoomRequest request, G2C_EnterRoomResponse response,
        Action reply)
    {
        if (string.IsNullOrEmpty(request.RoomCode))
        {
            response.ErrorCode = ErrorCode.MapRoomIdError;
            return;
        }

        var gateUnitSessionComponent = session.GetComponent<GateUnitSessionComponent>();
        if (gateUnitSessionComponent == null)
        {
            response.ErrorCode = ErrorCode.ErrServer;
            return;
        }

        // 在缓存中检查该账号是否存在
        var gateUnitManageComponent = session.Scene.GetComponent<GateUnitManageComponent>();
        if (gateUnitManageComponent == null)
        {
            response.ErrorCode = ErrorCode.ErrServer;
            return;
        }

        var gateUnit = gateUnitManageComponent.Get(gateUnitSessionComponent.AccountID);
        if (gateUnit == null)
        {
            response.ErrorCode = ErrorCode.ErrServer;
            return;
        }

        if (gateUnit.RoomCode == request.RoomCode)
        {
            response.ErrorCode = ErrorCode.MapRoomEnterRepeated;
            return;
        }
        

        RoomHelper.ParseCode(request.RoomCode, out var serviceId, out var roomId);
        if (serviceId < 1 || roomId < 1)
        {
            response.ErrorCode = ErrorCode.MapRoomIdError;
            return;
        }

        var sceneConfig = SceneConfigData.Instance.Get(serviceId);
        if (sceneConfig == null)
        {
            response.ErrorCode = ErrorCode.MapRoomIdError;
            return;
        }

        //先判断是否需要更换地图服务器
        var oldServerRouteId = gateUnit.GetAddress(sceneConfig.SceneType);
        Log.Info($"进入房间信息，mapRouteId={oldServerRouteId}-{sceneConfig.RouteId} serviceId={serviceId}");
        if (oldServerRouteId != sceneConfig.RouteId)
        {
            //先退出旧的服务
            var ret = await gateUnit.Offline(session.RuntimeId, RouteType.MapRoute);
            if (ret != 0)
            {
                response.ErrorCode = ErrorCode.MapRoomIdError;
                return;
            }

            //再进入新的服务
            ret = await gateUnit.Online(RouteType.MapRoute, sceneConfig);
            if (ret != 0)
            {
                response.ErrorCode = ErrorCode.MapRoomIdError;
                return;
            }
        }

        //执行进入房间操作
        var roomResponse = (Map2G_EnterRoomResponse)await session.Scene.NetworkMessagingComponent.CallInnerRoute(
            sceneConfig.RouteId, new G2Map_EnterRoomRequest()
            {
                AccountId = gateUnit.Id,
                RoomCode = request.RoomCode,
            });
        if (roomResponse.ErrorCode != 0)
        {
            response.ErrorCode = ErrorCode.MapRoomIdError;
            return;
        }

        gateUnit.RoomCode = request.RoomCode;

        response.Units = roomResponse.Units;
        response.RoomCode = request.RoomCode;
        response.ErrorCode = ErrorCode.Successful;
    }
}